package MT::Plugin::RemoveBlankAll;

use strict;
use MT::Template::Context;
use base qw(MT::Plugin);

my $plugin = new MT::Plugin::RemoveBlankAll({
    name        => 'RemoveBlankAll',
    version     => '0.10',
    description => 'Remove all space and tab.',
    author_name => 'ushi',
    author_link => 'http://momomomomo.moo.jp/',
    doc_link    => 'http://momomomomo.moo.jp/b/linux/2009/11/mt.html',

    registry => {
        tags => {
            block => {
                RemoveBlankAll => \&remove_blank_all_main,
            },
        },
    },
});

MT->add_plugin($plugin);

sub instance
{
	$plugin;
}

sub remove_blank_all_main
{
    my ($ctx, $args, $cond) = @_;

    my $builder = $ctx->stash('builder');
    my $tokens  = $ctx->stash('tokens');

    my $out = $builder->build ($ctx, $tokens, $cond);
    return $ctx->error ($builder->errstr) if !defined $out;

    my @list = split(/[\r\n]/, $out);
    $out = remove_blank_trim(@list);
    $out;
}

sub remove_blank_trim
{
    my @out = @_;
    my $txt = '';

    for (@out) {
#        s/^\s*(.*?)\s*$/$1/;
        s/^\s+//;
        s/\s+$//;
#        $txt .= $_ . "\n" if ($_ ne '');
        $txt .= $_;
    }

    return $txt;
}

1;
